C23456789012345678901234567890123456789012345678901234567890123456789012
C------ The above line is 72 characters long. Do not exceed it -------->
      program cg

      real lambda_min, lambda_max
      character*(*) lambda_units
      real minimum_distance
      integer check_discrepan_frequency_par
      character*(*) dip_dir, dipres_dir, conv_dir
      character*(*) file_extension, name_coordinates
      character*(*) name_guess_par, name_epsilon
      logical excitation_evanescent_field_par
      logical excitation_plane_wave_par
      logical use_initial_guess
      logical multi_lambda_use_external_guess
      logical new_lambda_correction
      logical check_discrepan_if_q_incr
      logical always_check_discrepancy_par
      logical periodic_check_discrepancy_par
      logical reduce_error
      logical stop_at_maximum_iteration
      logical report_time
      logical report_iteration_time
      logical finite_size_effects
      logical always_use_drude
      logical always_use_other
      logical append_conversion_data
      logical execute_precise
      complex cu, cu3
c      
c----- The adjustable parameters follow this line listed by group ------
c
c-- Dimensions of arrays
      parameter (lx=100, ly=100, lz=100)  
      parameter (m_max = 500 000)
      parameter (namelength = 100)
      parameter (nmon=10000)

c-- Defining the incident wave
      parameter (excitation_evanescent_field_par = .false.) 
      parameter (excitation_plane_wave_par = .true.)        
      parameter (polx=1., poly=0., polz=0.)
      parameter (propx=0., propy=0., propz=1.)
      parameter (refractive_index = 1.52)
      parameter (theta_fraction_pi = 0.25)

c-- Controlling lambda's
      parameter (lambda_min=1000., lambda_max=1000.) 
      parameter (lambda_units = 'nanometers')
           ! allowed values: 'angstroms', 'nanometers', 'microns'
      parameter (nl_par = 1)

c-- I/O directories and filenames
      parameter (conv_dir = './')
      parameter (dip_dir = './')
      parameter (dipres_dir='./')
      parameter (file_extension = '.1')
      parameter (name_coordinates = './f.1')
      parameter (name_epsilon = './johnson.dat')
      parameter (name_guess_par = './d.1')

c-- Assignement of polarizability, alpha
      parameter (always_use_drude = .false.)  
      parameter (always_use_other = .false.)
      parameter (finite_size_effects = .false.)
      parameter (radius = 5.)  ! In nanometers

c-- Checking convergence of the cg program
      parameter (always_check_discrepancy_par = .false.)
      parameter (check_discrepan_frequency_par = 10)
      parameter (check_discrepan_if_q_incr = .false.)
      parameter (discrepan_par=0.001)
      parameter (error_fact_par=5.)
      parameter (error_par=0.1)
      parameter (maximum_iteration_number = 4000)
      parameter (periodic_check_discrepancy_par = .true.)
      parameter (reduce_error = .false.)
      parameter (stop_at_maximum_iteration = .false.)

c-- Using an initial guess
      parameter (multi_lambda_use_external_guess = .false.)
      parameter (new_lambda_correction = .false.)
      parameter (use_initial_guess = .false.)

c-- Reporting time and progress
      parameter (report_iteration_time = .true.)
      parameter (report_time = .true.)

c-- Miscellaneous
      parameter (append_conversion_data = .true.)
      parameter (execute_precise = .false.)
      parameter (minimum_distance = 0.9)
c
c----------- Do not change the parameters below this line --------------
c
      parameter ( cu = (0.,1.), cu3=(0.,3.) )
      parameter (nmon3 = 3*nmon)

      integer   dis(0:lx, 0:ly, 0:lz)
      integer*2 x(nmon), y(nmon), z(nmon)
      integer*2 alfa, beta, dr(3)
      real prop(3), pol(3)
      complex arg, arg_new, arg_old
      complex a(m_max), b(m_max)
      complex e, dzete, ki, dki, dkic, wij, wijc
      complex dx, dy, dz
      character*(namelength) name_conv, name_dip
      character*(namelength) name_dipres, name_guess
      character*(namelength) name_dip_pp
      character*(namelength) name_dipres_pp
      character*(namelength) name_conv_pp
      character*1 propchar, polchar
      character*8 ctime, cdate
      real lattice_unit, lambda
      complex rhp(nmon3)
      complex z0(nmon3)
      complex d(nmon3)
      complex g(nmon3)
      complex p(nmon3)
      complex w(nmon3)
      complex v(nmon3)
      complex diff(nmon3)
      real*8 pi, acfc, bcfc, sum_g, sum_v, sum_gnew
      logical flag, exist_flag1, exist_flag2, exist_flag3
      logical       exist_flag4, exist_flag5, exist_flag6, exist_flag_pp
      logical flag_short
      logical excitation_evanescent_field, excitation_plane_wave
      logical always_check_discrepancy, periodic_check_discrepancy

      external mkdircc
c
c-------------------------------------------------------------------
c
      if(report_time) then
         call time(ctime)
         call date(cdate)
         write(*,*) '---------------------------------------------------
     $---------'
         write(*,*) '---------------------------------------------------
     $---------'
         write(*,*) 'Beginning the conjugate-gradient program: ', 
     $              cdate, '  ', ctime
         write(*,*) '---------------------------------------------------
     $---------'
         write(*,*) '---------------------------------------------------
     $---------'
      end if
c
c------------ Initial settings -------------------------------------
c
      pi = 4.*datan(1.d0)
      lattice_unit = radius * (4.*pi / 3.)**(1./3.)
 2    format(a<namelength>)
c
c--------- Checking excitation field type
c
      excitation_evanescent_field = excitation_evanescent_field_par
      excitation_plane_wave       = excitation_plane_wave_par
      if(excitation_evanescent_field .eqv. excitation_plane_wave) then
         write(*,*) 'Warning: excitation type was not selected properly'
         if(execute_precise) goto 300
         write(*,*) 'Assuming excitation by a plane wave'
         excitation_evanescent_field = .false.
         excitation_plane_wave = .true.
      end if
      if(excitation_evanescent_field) then
         theta = pi * theta_fraction_pi
         if(refractive_index*sin(theta) .le. 1.) then
            write(*,*) 'Evanescent field excitation was chosen;'
            write(*,*) 'however, with the selected parameters'
            write(*,*) 'refractive_index=', refractive_index
            write(*,*) 'theta=', theta_fraction_pi, '*pi'
            write(*,*) 'there is no complete internal reflection.'
            if(execute_precise) goto 300
            write(*,*) 'Excitation by a plane wave will be'
            write(*,*) 'assumed in this calculation.'
            excitation_evanescent_field = .false.
            excitation_plane_wave = .true.
         end if
      end if
c
c-------- Checking discrepancy control mode
c
      always_check_discrepancy = always_check_discrepancy_par
      periodic_check_discrepancy = periodic_check_discrepancy_par
      if(always_check_discrepancy .and. periodic_check_discrepancy) then
         write(*,*) 'Warning: discrepancy control mode was specified'
         write(*,*) 'ambiguously. Check parameters:'
         write(*,*) 'always_check_discrepancy and
     $periodic_check_discrepancy'
         if(execute_precise) goto 300
         write(*,*) 'Assuming the following settings for 
     $this calculation:'
         write(*,*) 'always_check_discrepancy = .false.'
         write(*,*) 'periodic_check_discrepancy = .true.'
         always_check_discrepancy = .false.
         periodic_check_discrepancy = .true.
      end if
      if(periodic_check_discrepancy) then
         check_discrepan_frequency=check_discrepan_frequency_par
         if(check_discrepan_frequency .le. 0) then
            write(*,*) 'Warning: check_discrepan_frequency <= 0.'
            if(execute_precise) goto 300
            write(*,*) 'Assuming check_discrepan_frequency=100'
            check_discrepan_frequency = 100
         end if
      end if
c
c-------- Checking directories
c
      i_dip_dir    = len(dip_dir)
      i_dipres_dir = len(dipres_dir)
      i_conv_dir   = len(conv_dir)
      i_file_extension   = len(file_extension)
      i_name_coordinates = len(name_coordinates)
      i_name_epsilon = len(name_epsilon)

      inquire(file=dip_dir, exist=exist_flag1)
      if(.not. exist_flag1) then
         write(*,*) 'Fatal incompatibility of input encountered:'
         write(*,*) 'the directory to store dipole moments'
         write(*,90) dip_dir
 90      format(a<i_dip_dir>, ' does not exist.')
         write(*,*) 'Create the directory or change parameter 
     $ dip_dir; exiting.'
         goto 300
      end if

      inquire(file=dipres_dir, exist=exist_flag2)
      if(.not. exist_flag2) then
         write(*,*) 'Non-fatal incompatibility of input encountered:'
         write(*,*) 'Reserve directory to store dipole moments'
         write(*,91) dipres_dir
 91      format(a<i_dipres_dir>, ' does not exist.')
         if(execute_precise) goto 300
         write(*,*) 'Data can be lost; proceed at your own risk'
         write(*,*) 'or stop and create the directory or change 
     $ parameter dipres_dir'
      end if

      inquire(file=conv_dir, exist=exist_flag3)
      if(.not. exist_flag3) then
         write(*,*) 'Fatal incompatibility of input encountered:'
         write(*,*) 'the directory to store convergence data'
         write(*,92) conv_dir
 92      format(a<i_conv_dir>, ' does not exist.')
         write(*,*) 'Create the directory or change parameter 
     $ conv_dir; exiting.'
         goto 300
      end if

      inquire(file=name_coordinates, exist=exist_flag4)
      if(.not. exist_flag4) then
         write(*,*) 'Fatal incompatibility of input encountered:'
         write(*,*) 'the input file with coordinates'
         write(*,98) name_coordinates
 98      format(a<i_name_coordinates>, ' does not exist.')
         if(execute_precise) goto 300
         write(*,*) 'Create it or change parameter name_coordinates; 
     $ exiting.'
         goto 300
      end if

      inquire(file=name_epsilon, exist=exist_flag5)
      if(.not. exist_flag5) then
         write(*,*) 'Warning: the input file with epsilon data '
         write(*,99) name_epsilon
 99      format(a<i_name_epsilon>, ' is not found.')
         if((.not. always_use_drude) .and. 
     $      (.not. always_use_other)) then
            write(*,*) 'This file is required by the program.'
            if(execute_precise) goto 300
            write(*,*) 'But Drude formula will be used instead.'
         end if
      end if
c
c--------- Checking compatibility of lambda_min, lambda_max and nl
c
      nl = nl_par
      if(nl .le. 0) then
         write(*,*) 'Warning: unacceptable value: nl=', nl
         if(execute_precise) goto 300
         write(*,*) 'Assuming nl=1 in this calculation'
         nl = 1
      end if
      if(nl .eq. 1 .and. lambda_min .ne. lambda_max) then
         write(*,*) 'Warning: nl=1 but lambda_min =/= lambda_max'
         if(execute_precise) goto 300
         write(*,*) 'Assuming lambda = lambda_min in this calculation;'
         write(*,*) 'lambda_max ignored'
      end if
      if(nl .gt. 1 .and. lambda_min .eq. lambda_max) then
         write(*,*) 'Warning: nl>1 but lambda_min = lambda_max.'
         if(execute_precise) goto 300
         write(*,*) 'Assuming nl=1 and lambda = lambda_min in this 
     $ calculation;'
         write(*,*) 'lambda_max ignored.'
         nl = 1
      end if

      write(*,*) 'Lambda units: ', lambda_units
      if(lambda_units .eq. 'angstroms') then
         fact_lambda = 0.1
      else if(lambda_units .eq. 'nanometers') then
         fact_lambda = 1.0
      else if(lambda_units .eq. 'microns') then
         fact_lambda = 1000.
      else
         write(*,*) 'Illegal lambda_units'
         if(execute_precise) goto 300
         write(*,*) 'nanometers will be assumed for the lambda_units.'
         fact_lambda = 1.
      end if
c
c---------- Seting propchar and polchar (used for output
c                    filenames construction)
c
      propchar = 'u'
      polchar = 'u'

      if(excitation_evanescent_field) then
         propchar = 'e'
         polchar = 'e'
         write(*,*) 'Assuming excitation by evanescent field.'
         write(*,*) 'Parameters prop and pol are discarded.'
         write(*,*) 'Light falling at the angle', theta_fraction_pi, 
     $              '*pi to the internal surface.'
         write(*,*) 'Refractive index of the prism:', 
     $              refractive_index
         theta = pi * theta_fraction_pi
         prop(1) = refractive_index * sin(theta)
         prop(2) = 0.
         prop(3) = sqrt(prop(1)**2 - 1.)
         pol(1) = 0.
         pol(2) = 1.
         pol(3) = 0.
      end if

      if(excitation_plane_wave) then
         write(*,*) 'Assuming excitation by a plane wave'
         prop(1) = propx
         prop(2) = propy
         prop(3) = propz
         prop_mod = sqrt(prop(1)**2 + prop(2)**2 + prop(3)**2)
         if(prop_mod .ne. 1.) then
            write(*,*) 'Warning: prop_mod .ne. 1.'
            if(execute_precise) goto 300
            prop(1) = prop(1)/prop_mod
            prop(2) = prop(2)/prop_mod
            prop(3) = prop(3)/prop_mod
         end if
         if(abs(prop(1)-1.) .lt. 1e-7) propchar='x'
         if(abs(prop(2)-1.) .lt. 1e-7) propchar='y'
         if(abs(prop(3)-1.) .lt. 1e-7) propchar='z'
         pol(1) = polx
         pol(2) = poly
         pol(3) = polz       ! Light polarization direction
         pol_mod = sqrt(pol(1)**2 + pol(2)**2 + pol(3)**2)
         if(pol_mod .ne. 1.) then
            write(*,*) 'Warning: pol_mod .ne. 1.'
            if(execute_precise) goto 300
            pol(1) = pol(1)/pol_mod
            pol(2) = pol(2)/pol_mod
            pol(3) = pol(3)/pol_mod
         end if
         if(abs(pol(1)-1.) .lt. 1e-7) polchar='x'
         if(abs(pol(2)-1.) .lt. 1e-7) polchar='y'
         if(abs(pol(3)-1.) .lt. 1e-7) polchar='z'
      end if

      if(propchar .eq. 'u' .or. polchar .eq. 'u') then
         write(*,*) 'Warning: either propagation or polarization'
         write(*,*) 'direction does not coinside with x-y-z axes.'
         write(*,*) 'The ''unknown'' char (''u'') is assigned'
         write(*,*) 'in the corresponding position of the output path.'
      end if

c
c------ Creating output subdirectories
c
cc-- Comment the following lines if you do not want to use mkdircc
      write(name_dip_pp, 170) dip_dir, propchar, polchar
 170  format(a<i_dip_dir>, 'prop=', a1, '_pol=', a1)
      inquire(file=name_dip_pp, exist=exist_flag_pp)
      if(.not. exist_flag_pp) then
         call mkdircc(name_dip_pp)
         write(*,202) name_dip_pp
 202     format('Directory ', a<i_dip_dir+12>, ' created')
      end if

      write(name_dipres_pp, 171) dipres_dir, propchar, polchar
 171  format(a<i_dipres_dir>, 'prop=', a1, '_pol=', a1)
      inquire(file=name_dipres_pp, exist=exist_flag_pp)
      if(.not. exist_flag_pp) then
         call mkdircc(name_dipres_pp)
         write(*,203) name_dipres_pp
 203     format('Directory ', a<i_dipres_dir+12>, ' created')
      end if

      write(name_conv_pp, 172) conv_dir, propchar, polchar
 172  format(a<i_conv_dir>, 'prop=', a1, '_pol=', a1)
      inquire(file=name_conv_pp, exist=exist_flag_pp)
      if(.not. exist_flag_pp) then
         call mkdircc(name_conv_pp)
         write(*,204) name_conv_pp
 204     format('Directory ', a<i_conv_dir+12>, ' created')
      end if
cc-- Stop commenting here (if you decided not to use mkdircc)
c
c-------------- Checking that k E_0 = 0
c
      sclprod = prop(1)*pol(1) + prop(2)*pol(2) + prop(3)*pol(3)
      if(sclprod .gt. 1.e-10) then
            write(*,*) 'Error: k and E are not orthogonal.'
            if(execute_precise) goto 300
            write(*,*) 'Either stop and correct input or continue'
            write(*,*) 'at your own risk'
      end if            
c
c------------- Checking the prescription for polarizability
c
      if(always_use_drude .and. always_use_other) then
         write(*,*) 'Warning: both always_use_drude and'
         write(*,*) 'always_use_other were set to .true.'
         if(execute_precise) goto 300
         write(*,*) 'The drude formula will be used.'
      end if
c
c---------- Reading dipole coordinates from a file ------------
c
      open(unit=70, file=name_coordinates, status='old', err=96)
      goto 97
 96   continue
      write(*,*) 'File with coordinates ',
     $           name_coordinates, ' couldnt be open.'
      write(*,*) 'Please check directories or parameter 
     $ name_coordinates; exiting.'
      goto 300
 97   continue
      
      ixmin =  1e6
      ixmax = -1e5
      iymin =  1e6
      iymax = -1e6
      izmin =  1e6
      izmax = -1e6
      n = 0
 3    continue
      read(70,*,end=4) ix, iy, iz
      n = n + 1
      if(ix .lt. ixmin) ixmin = ix
      if(ix .gt. ixmax) ixmax = ix
      if(iy .lt. iymin) iymin = iy
      if(iy .gt. iymax) iymax = iy
      if(iz .lt. izmin) izmin = iz
      if(iz .gt. izmax) izmax = iz
      if(excitation_evanescent_field .and. iz .lt. 0) then
         write(*,*) 'Warning: if excitation by evanescent field is'
         write(*,*) 'used, all z coordinates must be nonnegative,'
         write(*,*) 'but z(', i, ')=', iz
         if(execute_precise) goto 300
      end if
      x(n) = ix
      y(n) = iy
      z(n) = iz
      goto 3
 4    continue
      close(unit=70)
      n3 = 3*n

      ixd = ixmax - ixmin
      iyd = iymax - iymin
      izd = izmax - izmin
      write(*,*) 'Number of particles in the cluster:', n
      write(*,*) 'xmin=', ixmin, ',  xmax=', ixmax, ',  xmax-xmin=', ixd
      write(*,*) 'ymin=', iymin, ',  ymax=', iymax, ',  ymax-ymin=', iyd
      write(*,*) 'zmin=', izmin, ',  zmax=', izmax, ',  zmax-zmin=', izd
      if(ixd .gt. lx .or. iyd .gt. ly .or. izd .gt. lz) then
         write(*,*) 'Fatal incompatibility: lx, ly or lz'
         write(*,*) 'are too small. Use above info to set lx,ly and lz'
         write(*,*) 'for the cluster ', name_coordinates
         write(*,*) 'Exiting.'
         goto 300
      end if

      if(ixd .lt. lx) then
         write(*,*) 'Warning: lx is larger than x_max-x_min=', ixd
         write(*,*) 'Change parameter lx to save memory.'
      end if
      if(iyd .lt. ly) then
         write(*,*) 'Warning: ly is larger than y_max-y_min=', iyd
         write(*,*) 'Change parameter ly to save memory.'
      end if
      if(izd .lt. lz) then
         write(*,*) 'Warning: lz is larger than z_max-z_min=', izd
         write(*,*) 'Change parameter lz to save memory.'
      end if

      if(n .gt. nmon) then
         write(*,*) 'Fatal incompatibility: parameter nmon is less'
         write(*,*) 'than the number of monomers in the cluster,', n
         write(*,*) 'Correct parameter nmon; exiting'
         goto 300
      else if(n .lt. nmon) then
         write(*,*) 'Warning: parameter nmon is greater'
         write(*,*) 'than the number of monomers in the cluster,', n
         write(*,*) 'Correct parameter nmon to save memory;'
         write(*,*) 'continuing'
      end if
c
c-----------------------------------------------------------
c
      index_write = 0
      write(*,*) 'Beginning cycle over lambda'
         write(*,*) '---------------------------------------------------
     $---------'
         write(*,*) '---------------------------------------------------
     $---------'
c
c------------- Loop over lambda ---------------------------
c
      do 200, il=1,nl

      if(nl .eq. 1) then
         lambda = lambda_min
      else if(nl .gt. 1) then
         lambda = lambda_min + 
     $            (lambda_max-lambda_min)*float(il-1)/float(nl-1)
      else
         write(*,*) 'Unexpected fatal incompatibility; check code'
         goto 300
      end if
      llambda = lambda + 0.5  ! Closest integer to lambda in lambda_units
      ndec = alog10(lambda) + 1 ! Number of digits in integer llambda
      lambda = lambda*fact_lambda ! lambda converted to nanometers

      wave_vector = 2.*pi/lambda
      cons1 = lattice_unit*wave_vector
      cons2 = (wave_vector)**3
      cons3 = lattice_unit**3

      error = error_par
      discrepan = discrepan_par
      error_fact = error_fact_par
c
c------- Constructing output filenames
c
      write(name_dip, 70) dip_dir, propchar, polchar, 
     $   llambda, file_extension
 70   format(a<i_dip_dir>, 'prop=', a1, '_pol=', a1, '/d_l', 
     $   i<ndec>, a<i_file_extension>)

      write(name_dipres, 71) dipres_dir, propchar, polchar, 
     $   llambda, file_extension
 71   format(a<i_dipres_dir>, 'prop=', a1, '_pol=', a1, '/d_l', 
     $   i<ndec>, a<i_file_extension>)

      write(name_conv, 72) conv_dir, propchar, polchar, 
     $   llambda, file_extension
 72   format(a<i_conv_dir>, 'prop=', a1, '_pol=', a1, '/q_l', 
     $   i<ndec>, a<i_file_extension>)
      
      if(report_time) then
         call time(ctime)
         call date(cdate)
         write(*,*) '*********** lambda=', lambda, '[nm] **** ', 
     $              cdate, '  ', ctime, ' ****'
      else
         write(*,*) '*************** lambda=', lambda, 
     $              '[nm] ***************'
      end if
      write(*,73) name_dip
      write(*,74) name_dipres
      write(*,75) name_conv
 73   format('name_dip=',     a<namelength>)
 74   format('name_dipres=',  a<namelength>)
 75   format('name_conv=',    a<namelength>)

c
c-------- Calling a subroutine to calculate alpha
c      
      if(always_use_drude) then
         write(*,*) 'Using Drude formula'
         call sus_drude(lambda, radius, ki)
      else if(always_use_other) then
         write(*,*) 'Using <other> formula'
         call sus_other(lambda, radius, ki)
      else if(exist_flag5) then
         write(*,*) 'Reading epsilon data from file:', name_epsilon
         if(finite_size_effects) then
            call sus_eps(name_epsilon, lambda, radius, ki, flag)
         else
            call sus_eps0(name_epsilon, lambda, radius, ki, flag)
         end if
         if(flag) then
            write(*,*) 'lambda out of range for the datafile specified'
            write(*,*) 'or the epsilon-data file unreadable.'
            if(execute_precise) goto 300
            write(*,*) 'Using the Drude formula.'
            call sus_drude(lambda, radius, ki)
         else
            write(*,*) 'File ', name_epsilon, ' is OK'
         end if
      else
         write(*,*) 'File ', name_epsilon, ' does not exist;'
         if(execute_precise) goto 300
         write(*,*) 'Using Drude formula.'
         call sus_drude(lambda, radius, ki)
      end if

      dki = 1./ki
      write(*,*) '-Re[1/alpha]=', -cons3*Real(dki),';  -Im[1/alpha]=', 
     $            -cons3*Aimag(dki), ' [lattice units]'
      dkic = conjg(dki)
      yabs = -Aimag(dki) - 2.*(wave_vector**3)/3.
      write(*,*) 'alpha/radius^3=', ki/radius**3
      write(*,*) 'y_a/(2k^3/3)=', 3.*yabs/(2.*wave_vector**3)
c------------------------------------------------- end --------------



c-------------- Building elements of interaction matrix A and B -----
      if(report_time) then
         call time(ctime)
         call date(cdate)
         write(*,*) 'Building elements of matrix: ', cdate, '  ', ctime
      end if
      do 1, i=0,lz
      do 1, j=0,ly
      do 1, k=0,lx
      dis(k,j,i) = 0
 1    continue
      
      flag_short = .false.
      m = 0
      do 5, i=1,   n-1
      do 6, j=i+1, n
      ix = iabs(x(i) - x(j))
      iy = iabs(y(i) - y(j))
      iz = iabs(z(i) - z(j))
      if(dis(ix, iy, iz) .eq. 0) then
            m = m + 1
            if(m .gt. m_max) flag_short = .true.
                                              dis(ix,iy,iz)=m
            if(iz.le.ly .and. iy.le.lz)       dis(ix,iz,iy)=m
            if(iy.le.lx) then
                  if(ix.le.ly)                dis(iy,ix,iz)=m
                  if(ix.le.lz .and. iz.le.ly) dis(iy,iz,ix)=m
            end if
            if(iz.le.lx) then
                  if(ix.le.ly .and. iy.le.lz) dis(iz,ix,iy)=m
                  if(ix.le.lz)                dis(iz,iy,ix)=m
            end if
            rij2 = ix*ix + iy*iy + iz*iz
            rij  = sqrt(rij2)
            if(rij .lt. minimum_distance) then
               write(*,*) 'Warning: incompatibility 
     $of the coordinates file:'
               write(*,*) 'Two particles closer than', minimum_distance
              if(execute_precise .or. rij .eq. 0.) goto 300
            end if
            zet = cons1*rij
            dzet = 1./zet
            dzet2 = dzet*dzet
            e = cexp(cu*zet)
            dzete = dzet*e*cons2
            if(.not. flag_short) then
               a(m) = -dzete*(1. + cu*dzet - dzet2)
               b(m) = -dzete*(-1. - cu3*dzet + 3.*dzet2)/rij2
            end if
      end if
 6    continue
c     write(*,*) i, m
 5    continue

      write(*,*) 'Number of independent translation vectors m_max=', m

      if(flag_short) then
         write(*,*) 'Fatal incompatibility: m_max=', m_max
         write(*,*) 'is too small. Use the above information'
         write(*,*) 'on maximum no. of independent translational'
         write(*,*) 'vectors to determine m_max. Exiting.'
         goto 300
      end if
      
      if(report_time) then
         call time(ctime)
         call date(cdate)
         write(*,*) 'Elements of matrix built: ', cdate, '  ', ctime
      end if

      if(m .lt. m_max) then
         write(*,*) 'Warning: parameter m_max=', m_max
         write(*,*) 'is greater than the number of independent'
         write(*,*) 'translational vectors.'
         write(*,*) 'Change m_max to save memory.'
      end if
c
c-----------------------------------------------------------------
c------------ Building right-hand part of the equation --------------
      do 9, i=1,n
      if(excitation_evanescent_field) then
         arg = x(i)*prop(1) + y(i)*prop(2) + (z(i)+0.5)*prop(3)*cu
      else if(excitation_plane_wave) then
         arg = x(i)*prop(1) + y(i)*prop(2) + z(i)*prop(3)
      else
         write(*,*) 'Unexpected fatal incompatibility; check code'
         goto 300
      end if
      arg = arg*cons1
      e = cexp(cu*arg)
      ii = 3*(i-1)
      do 9, alfa=1,3
      rhp(ii+alfa) = pol(alfa)*e
 9    continue

c------------------------------------------------- end --------------

c----------- Initial setup for conjugate gradients ---------------
c---- Equation to solve has the form Cd=rhp where
c- C = dki*delta(alfa,beta)*delta(i,j) - 
c-               - [1-delta(i,j)]*[a*delta(alfa,beta) + 
c-               + b*rij(alfa)*rij(beta)]
c-----------------------------------------------------------------

c.......... a) Initial guess .....................................
      if(.not. use_initial_guess) then
         goto 93
      else if(nl .eq. 1) then
         name_guess = name_guess_par
         goto 94
      else if(il .eq. 1 .and. multi_lambda_use_external_guess) then
         name_guess = name_guess_par
         goto 94
      else if(il .gt. 1 .and. index_write .ne. 0) then
         goto 94
      else
         goto 93
      end if

      goto 93
 95   continue
      write(*,*) 'The initial guess file was specified but unreadable.'
      if(execute_precise) goto 300
 93   continue
      write(*,*) 'Using first Born approximation for the initial guess.'
      do 14, i=1,n3
      d(i) = ki*rhp(i)
 14   continue
      goto 100

 94   continue
      open(unit=70, file=name_guess, status='old', access='direct', 
     $     recl=24, err=95)
      do 8, i=1,n
      ii = 3*(i-1)
      read(70, rec=i,err=95) dx, dy, dz
      e = (1.,0.)
      if(il .gt. 1 .and. new_lambda_correction) then
         if(excitation_evanescent_field) then
            arg = x(i)*prop(1) + y(i)*prop(2) + (z(i)+0.5)*prop(3)*cu
         else if(excitation_plane_wave) then
            arg = x(i)*prop(1) + y(i)*prop(2) + z(i)*prop(3)
         else
            write(*,*) 'Unexpected fatal incompatibility; check code'
            goto 300
         end if
         arg_new = arg*cons1
         arg_old = arg*cons1_old
         e = cexp(cu*(arg_new - arg_old))
      end if
      d(ii+1) = dx*e
      d(ii+2) = dy*e
      d(ii+3) = dz*e
 8    continue
      close(unit=70)
      write(*,*) 'Initial guess successfully read from file.'

 100  continue
c\\\\\\\\\
c.......... b) Establishing vectors z0 = C+*rhp, w=Cd .........
      do 10, i=1,n3
      z0(i) = dkic * rhp(i)
      w (i) = dki  * d(i)
 10   continue
      
      do 11, i=1,n-1
      ii = 3*(i-1)
      do 11, j=i+1,n
      jj = 3*(j-1)
      dr(1) = x(i) - x(j)
      dr(2) = y(i) - y(j)
      dr(3) = z(i) - z(j)
      m = dis( iabs(dr(1)), iabs(dr(2)), iabs(dr(3))  )

      do 12, alfa=1,2
      i1 = ii + alfa
      i3 = jj + alfa
      do 12, beta=alfa+1,3
      if(dr(alfa) .eq. 0 .or. dr(beta) .eq. 0) goto 12
      i2 = ii + beta
      i4 = jj + beta
      wij = b(m)*dr(alfa)*dr(beta)
      wijc = conjg(wij)
      z0(i1) = z0(i1) + wijc*rhp(i4)
      z0(i2) = z0(i2) + wijc*rhp(i3)
      z0(i3) = z0(i3) + wijc*rhp(i2)
      z0(i4) = z0(i4) + wijc*rhp(i1)
      w (i1) = w (i1) + wij*d(i4)
      w (i2) = w (i2) + wij*d(i3)
      w (i3) = w (i3) + wij*d(i2)
      w (i4) = w (i4) + wij*d(i1)
 12   continue
      
      do 13, alfa=1,3
      i1 = ii + alfa
      i2 = jj + alfa
      wij = a(m)
      if(dr(alfa) .ne. 0) wij = wij + b(m)*dr(alfa)*dr(alfa)
      wijc = conjg(wij)
      z0(i1) = z0(i1) + wijc*rhp(i2)
      z0(i2) = z0(i2) + wijc*rhp(i1)
      w (i1) = w (i1) + wij*d(i2)
      w (i2) = w (i2) + wij*d(i1)
 13   continue

 11   continue
      if(report_time) then
         call time(ctime)
         call date(cdate)
         write(*,*) 'z0 and w established: ', cdate, '  ', ctime
      end if
c\\\\\\
c..... c) establishing vectors g=p ...................
c//////
      do 19, i=1,n3
      g(i) = dkic*w(i)
 19   continue
      
      do 20, i=1,n-1
      ii = 3*(i-1)
      do 20, j=i+1,n
      jj = 3*(j-1)
      dr(1) = x(i) - x(j)
      dr(2) = y(i) - y(j)
      dr(3) = z(i) - z(j)
      m = dis( iabs(dr(1)), iabs(dr(2)), iabs(dr(3))  )

      do 21, alfa=1,2
      i1 = ii + alfa
      i3 = jj + alfa
      do 21, beta=alfa+1,3
      if(dr(alfa) .eq. 0 .or. dr(beta) .eq. 0) goto 21
      i2 = ii + beta
      i4 = jj + beta
      wij = b(m)*dr(alfa)*dr(beta)
      wijc = conjg(wij)
      g(i1) = g(i1) + wijc*w(i4)
      g(i2) = g(i2) + wijc*w(i3)
      g(i3) = g(i3) + wijc*w(i2)
      g(i4) = g(i4) + wijc*w(i1)
 21   continue
      
      do 22, alfa=1,3
      i1 = ii + alfa
      i2 = jj + alfa
      wij = a(m)
      if(dr(alfa) .ne. 0) wij = wij + b(m)*dr(alfa)*dr(alfa)
      wijc = conjg(wij)
      g(i1) = g(i1) + wijc*w(i2)
      g(i2) = g(i2) + wijc*w(i1)
 22   continue

 20   continue
c///////
      do 23, i=1,n3
      g(i) = z0(i) - g(i)
      p(i) = g(i)
 23   continue
c\\\\
c....... establishing vector v = Cp ...........
c////
      do 24, i=1,n3
      v(i) = dki*p(i)
 24   continue
      
      do 25, i=1,n-1
      ii = 3*(i-1)
      do 25, j=i+1,n
      jj = 3*(j-1)
      dr(1) = x(i) - x(j)
      dr(2) = y(i) - y(j)
      dr(3) = z(i) - z(j)
      m = dis( iabs(dr(1)), iabs(dr(2)), iabs(dr(3))  )

      do 26, alfa=1,2
      i1 = ii + alfa
      i3 = jj + alfa
      do 26, beta=alfa+1,3
      if(dr(alfa) .eq. 0 .or. dr(beta) .eq. 0) goto 26
      i2 = ii + beta
      i4 = jj + beta
      wij = b(m)*dr(alfa)*dr(beta)
      v(i1) = v(i1) + wij*p(i4)
      v(i2) = v(i2) + wij*p(i3)
      v(i3) = v(i3) + wij*p(i2)
      v(i4) = v(i4) + wij*p(i1)
 26   continue
      
      do 27, alfa=1,3
      i1 = ii + alfa
      i2 = jj + alfa
      wij = a(m)
      if(dr(alfa) .ne. 0) wij = wij + b(m)*dr(alfa)*dr(alfa)
      v(i1) = v(i1) + wij*p(i2)
      v(i2) = v(i2) + wij*p(i1)
 27   continue

 25   continue
c///////
      if(report_time) then
         call time(ctime)
         call date(cdate)
         write(*,*) 'g and v established: ', cdate, '  ', ctime
      end if
c**************** Iterations ************************************
      iter = 0
 30   continue
      iter = iter + 1

      sum_g = 0.
      sum_v = 0.
      do 31, i=1,n3
      sum_g = sum_g + g(i)*conjg(g(i))
      sum_v = sum_v + v(i)*conjg(v(i))
 31   continue
      if(sum_g .lt. 1.e-15) then
         write(*,*) 'Limit of accuracy:'
         write(*,*) 'sum_g=', sum_g, '    sum_v=', sum_v
         goto 51
      end if
      acfc = sum_g/sum_v

     
      do 32, i=1,n3
      d(i) = d(i) + acfc*p(i)
      w(i) = w(i) + acfc*v(i)
 32   continue
      
c////////
      do 33, i=1,n3
      g(i) = dkic*w(i)
 33   continue
      
      do 34, i=1,n-1
      ii = 3*(i-1)
      do 34, j=i+1,n
      jj = 3*(j-1)
      dr(1) = x(i) - x(j)
      dr(2) = y(i) - y(j)
      dr(3) = z(i) - z(j)
      m = dis( iabs(dr(1)), iabs(dr(2)), iabs(dr(3))  )

      do 35, alfa=1,2
      i1 = ii + alfa
      i3 = jj + alfa
      do 35, beta=alfa+1,3
      if(dr(alfa) .eq. 0 .or. dr(beta) .eq. 0) goto 35
      i2 = ii + beta
      i4 = jj + beta
      wij = b(m)*dr(alfa)*dr(beta)
      wijc = conjg(wij)
      g(i1) = g(i1) + wijc*w(i4)
      g(i2) = g(i2) + wijc*w(i3)
      g(i3) = g(i3) + wijc*w(i2)
      g(i4) = g(i4) + wijc*w(i1)
 35   continue
      
      do 36, alfa=1,3
      i1 = ii + alfa
      i2 = jj + alfa
      wij = a(m)
      if(dr(alfa) .ne. 0) wij = wij + b(m)*dr(alfa)*dr(alfa)
      wijc = conjg(wij)
      g(i1) = g(i1) + wijc*w(i2)
      g(i2) = g(i2) + wijc*w(i1)
 36   continue

 34   continue
c///////
      do 37, i=1,n3
      g(i) = z0(i) - g(i)
 37   continue

      sum_gnew = 0.
      do 38, i=1,n3
      sum_gnew = sum_gnew + g(i)*conjg(g(i))
 38   continue
      bcfc = sum_gnew/sum_g
      
      do 39, i=1,n3
      p(i) = g(i) + bcfc*p(i)
 39   continue

c/////////////////
      do 40, i=1,n3
      v(i) = dki*g(i) + bcfc*v(i)
 40   continue
      
      do 41, i=1,n-1
      ii = 3*(i-1)
      do 41, j=i+1,n
      jj = 3*(j-1)
      dr(1) = x(i) - x(j)
      dr(2) = y(i) - y(j)
      dr(3) = z(i) - z(j)
      m = dis( iabs(dr(1)), iabs(dr(2)), iabs(dr(3))  )

      do 42, alfa=1,2
      i1 = ii + alfa
      i3 = jj + alfa
      do 42, beta=alfa+1,3
      if(dr(alfa) .eq. 0 .or. dr(beta) .eq. 0) goto 42
      i2 = ii + beta
      i4 = jj + beta
      wij = b(m)*dr(alfa)*dr(beta)
      v(i1) = v(i1) + wij*g(i4)
      v(i2) = v(i2) + wij*g(i3)
      v(i3) = v(i3) + wij*g(i2)
      v(i4) = v(i4) + wij*g(i1)
 42   continue
      
      do 43, alfa=1,3
      i1 = ii + alfa
      i2 = jj + alfa
      wij = a(m)
      if(dr(alfa) .ne. 0) wij = wij + b(m)*dr(alfa)*dr(alfa)
      v(i1) = v(i1) + wij*g(i2)
      v(i2) = v(i2) + wij*g(i1)
 43   continue

 41   continue
c///////
c------------- Evaluation of the cross-sections -------------
      if(iter .gt. 1) then
         qe_old = qe
         qa_old = qa
         qs_old = qs
      end if
      sum_e = 0.
      sum_a = 0.
      do 50, i=1,n3
      sum_e = sum_e + aimag( d(i) * conjg(rhp(i)) )
      sum_a = sum_a + d(i)*conjg(d(i))
 50   continue
      qe = 4.*wave_vector*sum_e/(float(n)*radius**2)
      qa = 4.*wave_vector*yabs*sum_a/(float(n)*radius**2)
      qs = qe - qa

      if(report_iteration_time) then
         call time(ctime)
         call date(cdate)
         write(*,*) 'Iteration:', iter, '  ', cdate, '   ', 
     $               ctime, '; qe=', qe
      end if

      if(.not. append_conversion_data .and. iter .eq. 1) then
         inquire(file=name_conv, exist=exist_flag6)
         if(exist_flag6) then
            open(unit=70, file=name_conv, status='old')
            close(unit=70, status='delete')
         end if
         open(unit=70, file=name_conv, access='append', 
     $        status='unknown')
         write(70,*) iter, qe, qa, qs
         close(unit=70)
      else
         open(unit=70, file=name_conv, access='append', 
     $        status='unknown')
         write(70,*) iter, qe, qa, qs
         close(unit=70)
      end if
c\\\\\\\\\\\\\
c----------- writing dipole moments ------------------
      open(unit=70, file=name_dip, status='unknown', 
     $     access='direct', recl=24, err=81)
      do 80, i=1,n
      ii = 3*(i-1)
      write(70, rec=i, err=81) d(ii+1), d(ii+2), d(ii+3)
 80   continue
      close(unit=70)
      index_write = 1

      goto 82
 81   continue

      open(unit=70, file=name_dipres, status='unknown', 
     $     access='direct', recl=24, err=84)
      do 83, i=1,n
      ii = 3*(i-1)
      write(70, rec=i, err=84) d(ii+1), d(ii+2), d(ii+3)
 83   continue
      close(unit=70)
      index_write = 2
      
      goto 82
 84   continue
      index_write = 0
      write(*,*) 'Iteration', iter, ':  failing to write dipoles file'
 82   continue
c\\\\\\\\\\\\\
c------------ Checking convergence of cross sections -----------
      if(always_check_discrepancy) then
         goto 51
      else if(periodic_check_discrepancy) then
         if(mod(iter,check_discrepan_frequency) .eq. 0) goto 51
      else
         if(iter .le. 1) goto 30
         if(check_discrepan_if_q_incr) then
            if(abs(qe-qe_old) .lt. error .and. qe .gt. qe_old) goto 51
         else
            if(abs(qe-qe_old) .lt. error) goto 51
         end if
      end if

      if(stop_at_maximum_iteration .and. 
     $   iter .ge. maximum_iteration_number) goto 51

      goto 30
 51   continue
c\\\\\\\\\\\\\\\
c------------ Checking discrepancy ----------------
      do 52, i=1,n3
      diff(i) = dki*d(i)
 52   continue
      
      do 53, i=1,n-1
      ii = 3*(i-1)
      do 53, j=i+1,n
      jj = 3*(j-1)
      dr(1) = x(i) - x(j)
      dr(2) = y(i) - y(j)
      dr(3) = z(i) - z(j)
      m = dis( iabs(dr(1)), iabs(dr(2)), iabs(dr(3))  )

      do 54, alfa=1,2
      i1 = ii + alfa
      i3 = jj + alfa
      do 54, beta=alfa+1,3
      if(dr(alfa) .eq. 0 .or. dr(beta) .eq. 0) goto 54
      i2 = ii + beta
      i4 = jj + beta
      wij = b(m)*dr(alfa)*dr(beta)
      diff(i1) = diff(i1) + wij*d(i4)
      diff(i2) = diff(i2) + wij*d(i3)
      diff(i3) = diff(i3) + wij*d(i2)
      diff(i4) = diff(i4) + wij*d(i1)
 54   continue
      
      do 55, alfa=1,3
      i1 = ii + alfa
      i2 = jj + alfa
      wij = a(m)
      if(dr(alfa) .ne. 0) wij = wij + b(m)*dr(alfa)*dr(alfa)
      diff(i1) = diff(i1) + wij*d(i2)
      diff(i2) = diff(i2) + wij*d(i1)
 55   continue

 53   continue

      sum = 0.
      do 56, i=1,n3
      sum = sum + ( cabs(diff(i) - rhp(i)) )**2
 56   continue
      sum = sum/float(n3)
      sum = sqrt(sum)

      if(report_iteration_time) then
         write(*,*) '  Discrepancy: ', sum
      else if(report_time) then
         call time(ctime)
         call date(cdate)
         write(*,*) 'iteration:', iter, '  Discrepancy: ', sum,
     $              '   ', cdate, '   ', ctime
      else
         write(*,*) 'iteration:', iter, '  Discrepancy: ', sum
      end if

      if(stop_at_maximum_iteration .and. 
     $   iter .ge. maximum_iteration_number) goto 201

      if(sum .gt. discrepan) then
         if(reduce_error) error = error/error_fact
         goto 30
      end if

 201  continue
      cons1_old = cons1
      if(index_write .eq. 1) name_guess = name_dip
      if(index_write .eq. 2) name_guess = name_dipres

c     write(*,*) 'index_write=', index_write

 200  continue
c-----------------------------------------------------------------
      goto 301
 300  continue
      write(*,*) 'Either a fatal incompatibility was encountered'
      write(*,*) 'or parameter execute_precise was set to .true.'
      write(*,*) 'and a non-fatal incompatibility has occured.'
      write(*,*) 'Check the program output for warnings.'
 301  continue
      if(report_time) then
         call time(ctime)
         call date(cdate)
         write(*,*) '---------------------------------------------------
     $----------'
         write(*,*) '---------------------------------------------------
     $----------'
         write(*,*) 'Exiting the conjugate-gradient program: ', 
     $               cdate, '  ', ctime
         write(*,*) '---------------------------------------------------
     $----------'
         write(*,*) '---------------------------------------------------
     $----------'
      end if

      stop
      end

cccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
ccc                                                        ccc
ccc               S U B R O U T I N E S                    ccc
ccc                                                        ccc
cccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc

        SUBROUTINE SUS_EPS(NAME_EPS, LAMBDA, RADIUS, KI, FLAG)

        COMPLEX KI
        REAL LAMBDA
        CHARACTER*(*) NAME_EPS
        COMPLEX xill, cu, eps
        REAL L, L_OLD, L_MIN, L_MAX, LAMBDA_P, K, K3
        LOGICAL FLAG

        FLAG = .FALSE.
	PI = 4.*ATAN(1.)
	CU = (0.,1.)
	a = radius	! Radius of monomer [nm]
	ag = a*1.4	! Radius of electron confinment
	a2 = a*a	! Radius squared
	a3 = a*a*a	! Radius cubed
	lambda_p = 136.1! Wavelength (of the incident wave) 
			! at the frequency corresponding to 
			! plasmon resonance of silver [nm]
	g_inf = .0019	! Gamma for bulk silver (the constant
			! appearing in the Drude formula) devided
			! by the plasmon frequency for silver
	vf = .0047	! Fermi velocity for silver devided
			! by the velocity of light
	eps_ext = 1.	! dielectric permiability of external
c	eps_ext = 1.78	! media (=1. default). For clusters in
			! water change 1. to 1.78;
c       eps_ext = 1.53  ! In gelatin: change to 1.53

C********************************************************************
        OPEN(UNIT=70, FILE=NAME_EPS, STATUS='OLD', ERR=100)	

        l_min = 10000.
        l_max = 0.
        read(70,*,end=13, err=100) l, r1, r2
        if(l .lt. l_min) l_min = l
        if(l .gt. l_max) l_max = l
        i = 1
        l_old = l
        r1_old = r1
        r2_old = r2

12	continue
	read(70,*,end=13, err=100) l, r1, r2
        if(l .lt. l_min) l_min = l
        if(l .gt. l_max) l_max = l
	i = i + 1
        if(l .eq. lambda) goto 13
        if( (lambda-l_old)*(lambda-l) .le. 0.) then
           r1 = r1_old + (lambda-l_old)*(r1-r1_old)/(l-l_old)
           r2 = r2_old + (lambda-l_old)*(r2-r2_old)/(l-l_old)
           goto 13
        end if
        l_old = l
        r1_old = r1
        r2_old = r2
        goto 12
13      continue
        close (unit=70)
        if(l_min .gt. lambda .or. l_max .lt. lambda) then
           flag = .true.
           goto 101
        end if

        l = lambda
	k = 2.*pi/l
	k3 = k*k*k
	w = (l/lambda_p)
	w2 = w*w
	eps = (r1 + cu*r2)**2
	g_0 = w*g_inf
	g_a = g_0 + vf*(l/ag) / (2.*pi)
	eps = eps + w2*(1./(1. + cu*g_0) - 1./(1. + cu*g_a) )
	eps = eps/eps_ext
	xill = a3*(eps - 1.)/(eps + 2.)
	ki = xill/(1. - cu*(2.*k3/3.)*xill)

        goto 101
 100    CONTINUE
        flag = .true.
 101    continue

        RETURN
        END

c----------------------------------------------------------------

        SUBROUTINE SUS_EPS0(NAME_EPS, LAMBDA, RADIUS, KI, FLAG)

        COMPLEX KI
        REAL LAMBDA
        CHARACTER*(*) NAME_EPS
        COMPLEX xill, cu, eps
        REAL L, L_OLD, L_MIN, L_MAX, K, K3
        LOGICAL FLAG

        FLAG = .FALSE.
	PI = 4.*ATAN(1.)
	CU = (0.,1.)
	a = radius	! Radius of monomer [nm]
	a2 = a*a	! Radius squared
	a3 = a*a*a	! Radius cubed
	eps_ext = 1.	! dielectric permiability of external
c	eps_ext = 1.78	! media (=1. default). For clusters in
			! water change 1. to 1.78
c       eps_ext = 1.53  ! In gelatin: change to 1.53


C********************************************************************
        OPEN(UNIT=70, FILE=NAME_EPS, STATUS='OLD', ERR=100)	

        l_min = 100000.
        l_max = -1.
        read(70,*,end=13, err=100) l, r1, r2
        if(l .lt. l_min) l_min = l
        if(l .gt. l_max) l_max = l
        i = 1
        l_old = l
        r1_old = r1
        r2_old = r2

12	continue
	read(70,*,end=13, err=100) l, r1, r2
        if(l .lt. l_min) l_min = l
        if(l .gt. l_max) l_max = l
	i = i + 1
        if(l .eq. lambda) goto 13
        if( (lambda-l_old)*(lambda-l) .le. 0.) then
           r1 = r1_old + (lambda-l_old)*(r1-r1_old)/(l-l_old)
           r2 = r2_old + (lambda-l_old)*(r2-r2_old)/(l-l_old)
           goto 13
        end if
        l_old = l
        r1_old = r1
        r2_old = r2
        goto 12
13      continue
        close (unit=70)
        if(l_min .gt. lambda .or. l_max .lt. lambda) then
           flag = .true.
           goto 101
        end if

        l = lambda
	k = 2.*pi/l
	k3 = k*k*k
	eps = (r1 + cu*r2)**2
	xill = a3*(eps - 1.)/(eps + 2.)
	ki = xill/(1. - cu*(2.*k3/3.)*xill)

        goto 101
 100    CONTINUE
        flag = .true.

 101    continue
        RETURN
        END

c----------------------------------------------------------------

       SUBROUTINE SUS_DRUDE(LAMBDA, RADIUS, KI)
       REAL LAMBDA, LAMBDA_G, LAMBDA_P
       COMPLEX CU, EPS, KI_LL, KI

       PI = 4.*ATAN(1.)
       CU = (0.,1.)
       A = RADIUS
       EPS_EXT = 1.
       LAMBDA_P = 136.1
       LAMBDA_G = 71631.58
       GAMMA_OVER_OMEGA_P = LAMBDA_P / LAMBDA_G
       WAVE_VECTOR = 2.*PI/LAMBDA

       RL = LAMBDA/LAMBDA_P
       EPS = 1. - RL**2 / (1. + CU * GAMMA_OVER_OMEGA_P * RL)
       EPS = EPS/EPS_EXT
       KI_LL = A**3 * (EPS - 1.) / (EPS + 2.)
       KI = 1./(1./KI_LL - CU*(2./3.)*WAVE_VECTOR**3)

       RETURN
       END

c----------------------------------------------------------------

       SUBROUTINE SUS_OTHER(LAMBDA, RADIUS, KI)
       REAL LAMBDA
       COMPLEX CU, EPS, KI_LL, KI


       PI = 4.*ATAN(1.)
       CU = (0.,1.)
       A = RADIUS
       EPS_EXT = 1.

       WAVE_VECTOR = 2.*PI/LAMBDA
                     !
       EPS = (2.,1.) ! Change EPS or write another code for
                     ! determining EPS here
                     !
       EPS = EPS/EPS_EXT
       KI_LL = A**3 * (EPS - 1.) / (EPS + 2.)
       KI = 1./(1./KI_LL - CU*(2./3.)*WAVE_VECTOR**3)

       RETURN
       END

c----------------------------------------------------------------
